.\" gd_fragment_affixes.3.  The gd_fragment_affixes man page.
.\"
.\" Copyright (C) 2012, 2015 D. V. Wiebe
.\"
.\""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
.\"
.\" This file is part of the GetData project.
.\"
.\" Permission is granted to copy, distribute and/or modify this document
.\" under the terms of the GNU Free Documentation License, Version 1.2 or
.\" any later version published by the Free Software Foundation; with no
.\" Invariant Sections, with no Front-Cover Texts, and with no Back-Cover
.\" Texts.  A copy of the license is included in the `COPYING.DOC' file
.\" as part of this distribution.
.\"
.TH gd_fragment_affixes 3 "4 November 2015" "Version 0.9.1" "GETDATA"
.SH NAME
gd_fragment_affixes \(em report the field affixes of a fragment of a dirfile database
.SH SYNOPSIS
.B #include <getdata.h>
.HP
.nh
.ad l
.BI "int gd_fragment_affixes(DIRFILE *" dirfile ", int " fragment_index ,
.BI "char **" prefix ", char **" suffix );
.hy
.ad n
.SH DESCRIPTION
The
.BR gd_fragment_affixes ()
function queries a dirfile(5) database specified by
.I dirfile
and returns the field affixes for the fragment indexed by
.IR fragment_index .
The field prefix and suffix are appended to all field codes found in the
specified fragment.

The
.I prefix
and
.I suffix
parameters point to memory locations in which store the addresses of the
returned strings.

The
.I dirfile
argument must point to a valid DIRFILE object previously created by a call to
.BR gd_open (3).

.SH RETURN VALUE
Upon successful completion,
.BR gd_fragment_affixes ()
returns zero.  If non-empty, the prefix and suffix are reported in
.BR malloc (3)'d
buffers whose addresses are returned in
.BI * prefix
and
.BI * suffix\fR.
They should be deallocated by the caller when no longer needed by calling
.BR free (3).
If the fragment prefix or suffix is the empty string, NULL is returned in the
corresponding pointer.

On error, -1 is returned and sets the dirfile error to a non-zero error value.
In this case, the values of
.BI * prefix
and
.BI * suffix
are unspecified, but will NOT be pointers to valid allocated memory.  Possible
dirfile error values are:
.TP 8
.B GD_E_BAD_DIRFILE
The supplied dirfile was invalid.
.TP
.B GD_E_BAD_INDEX
The supplied index was out of range.
.PP
The dirfile error may be retrieved by calling
.BR gd_error (3).
A descriptive error string for the last error encountered can be obtained from
a call to
.BR gd_error_string (3).
.SH SEE ALSO
.BR gd_alter_frameoffset (3),
.BR gd_include_affixes (3),
.BR gd_open (3),
.BR dirfile (5),
.BR dirfile-format (5)
